/******************************************************************************
 * minimos.h
 * Federico Bareilles
 * 08/02/2003
 *
 * Minimos cuadrados no lineales.
 *
 *****************************************************************************/
#ifndef __MINIMOS_H
#define __MINIMOS_H

/* Errors codes */
#define MAT_SINGULAR  1     /* Singular Matrix */
#define MAX_ITERATION 2     /* Max count alcanced in iteration fiting */


struct derivada{
  double (*func)(double x, double *p);
  struct derivada *next;
};


struct model{
  int parametros;
  double *xdata;
  double *ydata;
  double *sigma;
  double e;
  int max_iter;
  int size;
  double (*modelo)(double x, double *p);
  struct derivada *deriv;
  struct derivada *current;
  struct matrix *VCV; /* matriz de Varianza Covarianza */
};


struct model *make_model( double (*modelo)());
int model_add_deriv(struct model *m, double (*func)());
int fit_model(struct model *m, double *xx);


#endif
